searchData={"content_type":"text/markdown","items":[{"doc":"This module it's in this moment just a representative module, nothing to use here keep reading","ref":"FlEx.html","title":"FlEx","type":"module"},{"doc":"All the render functions\n\n> This module contains wont be used never, instead use the module `FlEx.Renderer` that will be created once compiled\nthe first time","ref":"FlEx.RendererFunctions.html","title":"FlEx.RendererFunctions","type":"module"},{"doc":"This module contains the routing implementation where you can define routes, pipelines for every route\n\nExample:\n\n```elixir\ndefmodule MyApp.SomeRouter do\n  use FlEx.Router\n\n  plug :accepts, [\"json\"]\n\n  scope \"/api/v1\" do\n    get \"/your_page\", MyApp.SomeOtherModule, :function_name\n  end\nend\n```","ref":"FlEx.Router.html","title":"FlEx.Router","type":"module"},{"doc":"The server module it's the main piece of the server, can be the only router or just a router forwarder, in all cases\nit's the init of all\n\nExample:\n\n```elixir\ndefmodule MyApp.Server do\n  use FlEx.Server, otp_app: :my_app\n\n  plug Plug.Head\n  plug Plug.RequestId\n\n  # define directly your route\n  get \"/your_page/:param\", :my_func\n\n  def my_func(conn, %{\"param\" => param} = _params) do\n    conn\n    |> FlEx.Renderer.status(200)\n    |> FlEx.Renderer.json(%{some_key: \"your param\", param: param})\n  end\nend\n```","ref":"FlEx.Server.html","title":"FlEx.Server","type":"module"},{"doc":"Define a router module to forward all the request in case tha some request matches with the route\n\nExample:\n\n```\ndefine_router MyApp.SomeRouter","ref":"FlEx.Server.html#define_router/1","title":"FlEx.Server.define_router/1","type":"macro"},{"doc":"All the required to have an json api rest\n\nincludes a body parser (json, multipart and form post), method override to use put/patch/delete and other http methods","ref":"FlEx.Plug.ApiRestJson.html","title":"FlEx.Plug.ApiRestJson","type":"module"},{"doc":"","ref":"FlEx.Plug.ApiRestJson.html#call/2","title":"FlEx.Plug.ApiRestJson.call/2","type":"function"},{"doc":"","ref":"FlEx.Plug.ApiRestJson.html#init/1","title":"FlEx.Plug.ApiRestJson.init/1","type":"function"},{"doc":"Pre-configured logger with some presets depending the env","ref":"FlEx.Plug.Logger.html","title":"FlEx.Plug.Logger","type":"module"},{"doc":"","ref":"FlEx.Plug.Logger.html#call/2","title":"FlEx.Plug.Logger.call/2","type":"function"},{"doc":"","ref":"FlEx.Plug.Logger.html#init/1","title":"FlEx.Plug.Logger.init/1","type":"function"},{"doc":"This module contains all the needed stuff to test your server and all the routers\n\nExample:\n\n```elixir\ndefmodule Your.Server.ConnTest do\n  defmacro __using__(_) do\n    quote do\n      use FlEx.ConnTest, endpoint: Your.Server.Module\n\n      setup %{conn: conn} do\n        {:ok, conn: put_req_header(conn, \"accept\", \"application/json\")}\n      end\n    end\n  end\nend\n```\n\nand add the line `use Your.Server.ConnTest` to your test file","ref":"FlEx.ConnTest.html","title":"FlEx.ConnTest","type":"module"},{"doc":"Creates a connection.","ref":"FlEx.ConnTest.html#build_conn/0","title":"FlEx.ConnTest.build_conn/0","type":"function"},{"doc":"Creates a connection with a preset method, path and body.","ref":"FlEx.ConnTest.html#build_conn/3","title":"FlEx.ConnTest.build_conn/3","type":"function"},{"doc":"Ensures the connection is recycled ans recycles in case that wasn't.","ref":"FlEx.ConnTest.html#ensure_recycled/1","title":"FlEx.ConnTest.ensure_recycled/1","type":"function"},{"doc":"Asserts the given status code, that we have a json response and\nreturns the decoded JSON response if one was set or sent.","ref":"FlEx.ConnTest.html#json_response/2","title":"FlEx.ConnTest.json_response/2","type":"function"},{"doc":"body = json_response(conn, 200)\n    assert \"can't be blank\" in body[\"errors\"]","ref":"FlEx.ConnTest.html#json_response/2-examples","title":"Examples - FlEx.ConnTest.json_response/2","type":"function"},{"doc":"Recycles the connection.\n\nRecycling receives a connection and returns a new connection,\ncontaining cookies and relevant information from the given one.\n\nThis emulates behaviour performed by browsers where cookies\nreturned in the response are available in following requests.\n\nNote `recycle/1` is automatically invoked when dispatching\nto the endpoint, unless the connection has already been\nrecycled.","ref":"FlEx.ConnTest.html#recycle/2","title":"FlEx.ConnTest.recycle/2","type":"function"},{"doc":"Dispatch a call to the server under the request parameters defined in params","ref":"FlEx.ConnTest.html#request/5","title":"FlEx.ConnTest.request/5","type":"function"},{"doc":"Asserts the given status code and returns the response body\nif one was set or sent.","ref":"FlEx.ConnTest.html#response/2","title":"FlEx.ConnTest.response/2","type":"function"},{"doc":"conn = get(build_conn(), \"/\")\n    assert response(conn, 200) =~ \"hello world\"","ref":"FlEx.ConnTest.html#response/2-examples","title":"Examples - FlEx.ConnTest.response/2","type":"function"},{"doc":"Returns the content type as long as it matches the given format.","ref":"FlEx.ConnTest.html#response_content_type/2","title":"FlEx.ConnTest.response_content_type/2","type":"function"},{"doc":"# Assert we have an html response with utf-8 charset\n    assert response_content_type(conn, :html) =~ \"charset=utf-8\"","ref":"FlEx.ConnTest.html#response_content_type/2-examples","title":"Examples - FlEx.ConnTest.response_content_type/2","type":"function"},{"doc":"Contains the type of response handling and more helpers for all kinds of possible servers that you can create\n\nThis module it's pre-imported in the module `FlEx.ConnTest`","ref":"FlEx.Test.Helpers.html","title":"FlEx.Test.Helpers","type":"module"},{"doc":"Asserts the given status code, that we have a json response and\nreturns the decoded JSON response if one was set or sent.","ref":"FlEx.Test.Helpers.html#json_response/2","title":"FlEx.Test.Helpers.json_response/2","type":"function"},{"doc":"body = json_response(conn, 200)\n    assert \"can't be blank\" in body[\"errors\"]","ref":"FlEx.Test.Helpers.html#json_response/2-examples","title":"Examples - FlEx.Test.Helpers.json_response/2","type":"function"},{"doc":"Asserts the given status code and returns the response body\nif one was set or sent.","ref":"FlEx.Test.Helpers.html#response/2","title":"FlEx.Test.Helpers.response/2","type":"function"},{"doc":"conn = get(build_conn(), \"/\")\n    assert response(conn, 200) =~ \"hello world\"","ref":"FlEx.Test.Helpers.html#response/2-examples","title":"Examples - FlEx.Test.Helpers.response/2","type":"function"},{"doc":"Returns the content type as long as it matches the given format.","ref":"FlEx.Test.Helpers.html#response_content_type/2","title":"FlEx.Test.Helpers.response_content_type/2","type":"function"},{"doc":"# Assert we have an html response with utf-8 charset\n    assert response_content_type(conn, :html) =~ \"charset=utf-8\"","ref":"FlEx.Test.Helpers.html#response_content_type/2-examples","title":"Examples - FlEx.Test.Helpers.response_content_type/2","type":"function"},{"doc":"This module helps to store in module all the plugs defined in routers in the same definition sorting\n\n> This module it's just for internal use, it's not necessary implement","ref":"FlEx.Plug.PlugHandler.html","title":"FlEx.Plug.PlugHandler","type":"module"},{"doc":"","ref":"FlEx.Plug.PlugHandler.html#plug/2","title":"FlEx.Plug.PlugHandler.plug/2","type":"macro"},{"doc":"This module helps to handle the http method macros\n\n> This module it's just for internal use, it's not necessary implement","ref":"FlEx.Router.Methods.html","title":"FlEx.Router.Methods","type":"module"},{"doc":"Adds the path to the route list under the http method call\n\nExample:\n\n```\n  get \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  post \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  put \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  patch \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  delete \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n```","ref":"FlEx.Router.Methods.html#delete/4","title":"FlEx.Router.Methods.delete/4","type":"macro"},{"doc":"Adds the path to the route list under the http method call\n\nExample:\n\n```\n  get \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  post \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  put \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  patch \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  delete \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n```","ref":"FlEx.Router.Methods.html#get/4","title":"FlEx.Router.Methods.get/4","type":"macro"},{"doc":"Adds the path to the route list under the http method call\n\nExample:\n\n```\n  get \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  post \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  put \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  patch \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  delete \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n```","ref":"FlEx.Router.Methods.html#patch/4","title":"FlEx.Router.Methods.patch/4","type":"macro"},{"doc":"Adds the path to the route list under the http method call\n\nExample:\n\n```\n  get \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  post \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  put \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  patch \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  delete \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n```","ref":"FlEx.Router.Methods.html#post/4","title":"FlEx.Router.Methods.post/4","type":"macro"},{"doc":"Adds the path to the route list under the http method call\n\nExample:\n\n```\n  get \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  post \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  put \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  patch \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  delete \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n```","ref":"FlEx.Router.Methods.html#put/4","title":"FlEx.Router.Methods.put/4","type":"macro"},{"doc":"Adds the path as prefix and the defined plugs for all the scoped routes\n\nExample:\n\n```\n  scope \"/api/v1\" do\n    plug FlEx.Plug.Logger\n\n    get \"/your_scoped_page\", FlExExample.ExampleController, :function_name\n  end\n```","ref":"FlEx.Router.Methods.html#scope/2","title":"FlEx.Router.Methods.scope/2","type":"macro"},{"doc":"THis module helps to start the Plug.Cowboy server with the Supervisor\n\n> This module it's just for internal use, it's not necessary implement","ref":"FlEx.Server.Cowboy.html","title":"FlEx.Server.Cowboy","type":"module"},{"doc":"","ref":"FlEx.Server.Cowboy.html#specs/2","title":"FlEx.Server.Cowboy.specs/2","type":"function"},{"doc":"This module handles the Plug Cowboy http call, evaluating the request and redirecting to the right controller\n\n> This module it's just for internal use, it's not necessary implement","ref":"FlEx.Server.Request.html","title":"FlEx.Server.Request","type":"module"},{"doc":"The process supervisor for the server\n\n> This module it's just for internal use, it's not necessary implement","ref":"FlEx.Server.Supervisor.html","title":"FlEx.Server.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"FlEx.Server.Supervisor.html#child_spec/1","title":"FlEx.Server.Supervisor.child_spec/1","type":"function"},{"doc":"Starts the server","ref":"FlEx.Server.Supervisor.html#start_link/3","title":"FlEx.Server.Supervisor.start_link/3","type":"function"},{"doc":"","ref":"FlEx.Server.Request.RouteNotFoundException.html","title":"FlEx.Server.Request.RouteNotFoundException","type":"exception"},{"doc":"","ref":"readme.html","title":"README","type":"extras"},{"doc":"FlEx it's a micro-framework for backend inspired by the simplicity of Flask and the complication to use Phoenix in very\nsmall applications\n\nOne of the cores of this micro-framework it's be flexible, you can define your whole app in a single file or split in a \nlot of more files, basic rules, nothing to be followed\n\nThis project doesn't pretend to replace Phoenix, the opposite we LOVE Phoenix and we're taking a lot of inspiration on \nthe use and implementation of Phoenix, but sometimes a lot of stuff it's too overkill for some very small servers and \nmore when you want to create a very small service\n\nThe design it's based on [Plug](https://hexdocs.pm/plug/https.html) so it's FULLY COMPATIBLE WITH ALL THE PLUGS! and you\ncan create your own plugs in the same format and the same way to use, 100% compatibility\n\nAlso includes some useful plugs to create/configure your server quickly","ref":"readme.html#flex","title":"FlEx - README","type":"extras"},{"doc":"##","ref":"readme.html#concepts","title":"Concepts - README","type":"extras"},{"doc":"All the concepts are just described, the examples are in the guides and the module docs\n\nThe main piece it's the `server`, that contains the routes and the functions and this can be created using the module \n`FlEx.Server` and this contains all the core to handle routes\n\n##","ref":"readme.html#server","title":"Server - README","type":"extras"},{"doc":"Also it's not recommended have all in a single file so to divide the problem usin the routers, that can be created using\nthe module `FlEx.Router` and this can handle in the same way the routes, actually, `FlEx.Server` it's a router itself\n\n##","ref":"readme.html#routers","title":"Routers - README","type":"extras"},{"doc":"In the router you can define scopes of route, this will add the scoped route to the defined inner route as a prefix of \nthe route, so if you have `/some/route` with the scope `/api/v1` the final route will be `/api/v1/some/route` and all \nthe defined routes in the scope will have the same route prefix\n\n##","ref":"readme.html#router-scopes","title":"Router Scopes - README","type":"extras"},{"doc":"The router can define plugs, and this will be added to the execution of every route, also you can define exclusive plugs\nin the scope and another exclusive plugs in every router\n\n##","ref":"readme.html#router-pipelines","title":"Router pipelines - README","type":"extras"},{"doc":"Defining a route include the route and the function to call when the route it's called, and this function can be defined\nin the same router, or an external module, the concept says that must be named \"controller\" and it is, but this library\ndoesn't need implement a specific module for controllers, so you can just create your function in your module and just\nreceive 2 parameters in the function (the connection and the parameters)","ref":"readme.html#controller-handling","title":"Controller handling - README","type":"extras"},{"doc":"If [available in Hex](https://hex.pm/packages/fl_ex), the package can be installed\nby adding `fl_ex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:fl_ex, \"~> 0.1.1\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - README","type":"extras"},{"doc":"- [Basic Usage](./guides/basic_usage.md)\n- [Routing](./guides/routing.md)\n- [Configuration](./guides/configuration.md)\n- [Testing](./guides/testing.md)","ref":"readme.html#index","title":"Index - README","type":"extras"},{"doc":"This project includes a complete implementation example (server, routers, testing), just check the folder \n[fl_ex_example](./fl_ex_example)","ref":"readme.html#the-example","title":"The example - README","type":"extras"},{"doc":"- [x] Server\n- [x] Separated routers\n- [ ] Https\n- [ ] Live code changes\n- [ ] Render\n    - [x] JSON\n    - [ ] HTML\n- [x] Compatible with Plugs (100%)\n- [x] Plugs for whole router\n- [x] Plugs exclusive for `scope`\n- [ ] `pipeline` to create plug flows and refeer to `scope` or route\n- [x] Private plugs for specific routes\n- [ ] Testing\n    - [x] Basic json testing\n    - [ ] More helpers","ref":"readme.html#roadmap","title":"Roadmap - README","type":"extras"}]}